def fn backup%(file$,source_device$,dest_device$,forced_copy%)
rem this backs up the file file$ from the source device
rem to the destination device, and sets the date to that of the source.
rem It checks whether the date of the destination file is more recent than the
rem source file. If it is, it DOES NOT copy the file, unless the forced_copy%
rem flag is set (i.e.<>0). The date checked is the UPDATE date, not backup date.
rem this returns:
rem 1 if file copied and date set
rem 0 if destination was more recent than source and forced_copy% NOT set
rem >0 standard error codes if file error.
rem
local result%,date_source,date_dest,chan%
  chan%=fop_in(source_device$&file$)    : rem open source file ...
  if chan%<0:return chan%               : rem oops, what's this?
  date_source=fupdt(#chan%)             : rem get date
  close#chan%
  result%=ftest(dest_device$&file$)     : rem does this file exist on dest. device?
  if result%<0 and result%<>-7:return result% :rem oops, file problem
  if not result%
     chan%=fopen(dest_device$&file$)    : rem try to open existing file
     if chan%<0:return chan%            : rem file problem...
     date_dest=fupdt(#chan%)            : rem get file date
     close#chan%                        : rem ckose, and check dates
     if date_dest>date_source and not forced_copy%:return 0
  endif
  copy_o source_device$&file$,dest_device$&file$ :rem copy file
  chan%=fopen(dest_device$&file$)
  set_fupdt#chan%,date_source           : rem set the date of the source
  close#chan%
  return 1
end def backup%
