def fn get_prowess_printer% (choice%)
rem Choose a prowess printer, propose the one with ID choice%.
rem This presumes that at least one screen channel is open!
rem It returns 0 if no printer was chosen, else the prowess printer driver id
local Gstate,passes,nbr,pids$(100,100),a$
  PFGstateInit 0,'',2000,2000,0,0,Gstate,passes : rem make prowess gstate
  PFDriverCount Gstate,nbr		: rem get number of printer drivers
  dim pids$(nbr+1,100)			: rem and set array
  FOR lp=0 TO nbr
    a$=PFDriverNext$(Gstate,id) 	: rem format: prowess id + space +string
    pids$(lp)=id&" "&a$
  END FOR lp
  PFGstateRemove Gstate 		: rem this is no longer necessary
  if choice%
     a$=choice% 			: rem this was proposed
     nbr=asearch (pids$,a$,0,0) 	: rem find it in array
     if nbr<>-1
	a$=pids$(nbr)			: rem found make sure this is the one I want
	nbr=item_select ("Use this printer",a$,"Yes","No")
	select on nbr
	  =0 : return 0 		: rem no it isn't, ESC pressed
	  =1:return choice%		: rem yes it was, return it
	  =2: return propose_choice%	: rem no, so propsoe choice
	end select
     else
       return propose_choice%		: rem initial choice% not found, propsoe new list
    endif
  else
    return propose_choice%		: rem no choice proposed en entry
  endif
END DEFine get_prowess_printer%
:
def fn propose_choice%
local lp%,a$
  lp%=list_select("Use which printer",pids$,,0) : rem popose all printers
  if lp%<0:return 0			: rem ESC or OK pressed - none chosen
  a$=pids$(lp%) 			: rem choice
  lp%=" " instr a$			: rem extract prowess id after first space
  lp%=a$(1 to lp%-1)			: rem ... now
  return lp%				: rem and return it
end def propose_choice
:
