def proc make_standard_sprites
rem This makes standard move, sleep and wake sprites and sets the
rem GLOBAL vars move_sprite,, zzz_sprite, wake_sprite to them.
rem If there are system sprites, these are used.
rem This also makes the old "main_sprite" pointer sprite.
:
  espace_vide=ALCHP(100)	   : rem for pointers with no mask
:
  restore
  main_sprite=RD_SPRT(0)	   : REMark ici un masque normal
    DATA 11,13,6,5,4
    DATA '     www     '
    DATA '     waw     '
    DATA '     waw     '
    DATA '     waw     '
    DATA 'wwwwwa awwwww'
    DATA 'waaaa   aaaaw'
    DATA 'wwwwwa awwwww'
    DATA '     waw     '
    DATA '     waw     '
    DATA '     waw     '
    DATA '     www     '
:
  
  if sys_tspr_addr(6)<>0
    move_sprite=6
  else
    restore
    move_sprite=RD_SPRT(1)	     : REMark ici un masque 0
    DATA 10,14,5,4,4
    DATA 'aaaaaaaaaa    '
    DATA 'awwwwwwwwa    '
    DATA 'awwrrrrwwa    '
    DATA 'awwrrrrwwaaaaa'
    DATA 'awwrrwwwwwwwwa'
    DATA 'awwwwwwwwrrwwa'
    DATA 'aaaaawwrrrrwwa'
    DATA '    awwrrrrwwa'
    DATA '    awwwwwwwwa'
    DATA '    aaaaaaaaaa'
  endif
:
  if sys_tspr_addr(10)<>0
    sleep_sprite=10
  else
    restore
    sleep_sprite= RD_SPRT(1)		 : REMark ici un masque 0
    DATA 7,15,0,0,4
    DATA 'wwwww          '
    DATA '   w           '
    DATA '  w  wwww      '
    DATA ' w     w       '
    DATA 'wwwww w  wwww  '
    DATA '     wwww  w   '
    DATA '          wwww '
  endif
:
  if sys_tspr_addr(11)<>0
    wake_sprite=11
  else
    restore
    wake_sprite=RD_SPRT(1)	      : REMark ici un masque 0
    DATA 9,14,0,0,4
    DATA "             w"
    DATA "            w "
    DATA "      w   ww  "
    DATA "     ww www   "
    DATA "    wwwwww    "
    DATA "   www ww     "
    DATA "  w   w      "
    DATA " w            "
    DATA "w             "
  endif
:
  if sys_tspr_addr(7)<>0
    size_sprite=7
  else
    restore
    size_sprite=RD_SPRT(1)
    DATA 9,14,5,4,4
    DATA 'aaaaaaaaaaaaaa'
    DATA 'awwwwwwwwwwwwa'
    DATA 'awwrrrrrrrrwwa'
    DATA 'awwrrrrrrrrwwa'
    DATA 'awwrrwwwwwwwwa'
    DATA 'awwrrwwrrrrwwa'
    DATA 'awwrrwwrrrrwwa'
    DATA 'awwwwwwwwwwwwa'
    DATA 'aaaaaaaaaaaaaa'
  endif
:
end def make_sprites
:
